import { readdirSync, readFileSync } from 'fs'
import { resolve } from 'path'

const root = resolve(__dirname, '..', 'node_modules')
const Modules = new Set()

const nodePackages = readdirSync(root).filter(dirname => dirname.charAt(0) !== '.')

nodePackages.forEach((packageName) => {
  try {
    var json = JSON.parse(readFileSync(resolve(root, packageName, 'package.json')))
  } catch (error) {
    return
  }

  if (json.module || json.style || json['jsnext:main']) { Modules.add(packageName) }
})

export default Modules
