export default class Status {
  constructor(opts) {
    const { name, start, done } = opts
    this.name = name

    this.start = start
    this.done = done

    this.watcher = null
    this.running = false
  }

  checkDone = () => {
    this.running = false
    this.done()
  }

  apply(compiler) {
    compiler.plugin('done', (stats) => {
      if (!stats.hasErrors()) {
        this.watcher = setTimeout(this.checkDone, 100)
      }
    })

    compiler.plugin('compile', (stats) => {
      if (this.watcher) {
        clearTimeout(this.watcher)
      }

      if (!this.running) {
        this.running = true
        this.start()
      }
    })
  }
}
